import createMock from './MockFactory';

export default class MockObject {
  
  static fromPrototype(prototype) {
    let isFunction = (property) => {
      return typeof property === 'function';
    }

    let functions = Object.getOwnPropertyNames(prototype)
      .filter((p) => (isFunction(prototype[p])))
      .filter((p) => (p !== 'constructor'));
    return MockObject.fromFunctionNames(...functions);
  }

  static fromFunctionNames(...functionNames) {
    let mock = {};
    functionNames.forEach((fn) => mock[fn] = createMock());
    return mock;
  }
}